#ifndef ARMOR_COMPONENT_H_
#define ARMOR_COMPONENT_H_

#include "../backend/CBSEBackend.h"
#include "../backend/CBSEComponents.h"

class ArmorComponent: public ArmorComponentBase {

	public:
		// ///////////////////// //
		// Autogenerated Members //
		// ///////////////////// //

		/**
		 * @brief Default constructor of the ArmorComponent.
		 * @param entity The entity that owns the component instance.
		 * @note This method is an interface for autogenerated code, do not modify its signature.
		 */
		ArmorComponent(Entity& entity);

		/**
		 * @brief Handle the ApplyDamageModifier message.
		 * @param damage
		 * @param location
		 * @param direction
		 * @param flags
		 * @param meansOfDeath
		 * @note This method is an interface for autogenerated code, do not modify its signature.
		 */
		void HandleApplyDamageModifier(float& damage, Util::optional<Vec3> location, Util::optional<Vec3> direction, int flags, meansOfDeath_t meansOfDeath);

		// ///////////////////// //

		float GetLocationalDamageMod(float angle, float height);
		float GetNonLocationalDamageMod();

	private:

};

#endif // ARMOR_COMPONENT_H_

